UHD 003.005.002-0-unknown

- Main Page
- Namespaces
- Classes
- Files

- Class List
- Class Hierarchy
- Class Members

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Macros
Public Types | Static Public Member Functions | List of all members
uhd::transport::udp_zero_copy Class Reference

`#include <udp_zero_copy.hpp>`

Inheritance diagram for uhd::transport::udp_zero_copy:

## Public Types
typedef boost::shared_ptr < udp_zero_copy > | sptr
Public Types inherited from uhd::transport::zero_copy_if
typedef boost::shared_ptr < zero_copy_if > | sptr

## Static Public Member Functions
static sptr | make (const std::string &addr, const std::string &port, const device_addr_t &hints=device_addr_t())

## Additional Inherited Members
Public Member Functions inherited from uhd::transport::zero_copy_if
virtual managed_recv_buffer::sptr | get_recv_buff (double timeout=0.1)=0
virtual size_t | get_num_recv_frames (void) const =0
virtual size_t | get_recv_frame_size (void) const =0
virtual managed_send_buffer::sptr | get_send_buff (double timeout=0.1)=0
virtual size_t | get_num_send_frames (void) const =0
virtual size_t | get_send_frame_size (void) const =0

## Detailed Description

A zero copy udp transport provides an efficient way to handle data. by avoiding the extra copy when recv() or send() is called on the socket. Rather, the zero copy transport gives the caller memory references. The caller informs the transport when it is finished with the reference.

On linux systems, the zero copy transport can use a kernel packet ring. If no platform specific solution is available, make returns a boost asio implementation that wraps the functionality around a standard send/recv calls.

## Member Typedef Documentation

typedef boost::shared_ptr<udp_zero_copy> uhd::transport::udp_zero_copy::sptr

## Member Function Documentation

static sptr uhd::transport::udp_zero_copy::make | ( | const std::string & | addr,
|  | const std::string & | port,
|  | const device_addr_t & | hints = `device_addr_t()`
| ) |  |
| static

Make a new zero copy udp transport: This transport is for sending and receiving between this host and a single endpoint. The primary usage for this transport will be data transactions. The underlying implementation is fast and platform specific.

The address will be resolved, it can be a host name or ipv4. The port will be resolved, it can be a port type or number.

Parameters

  addr | a string representing the destination address
  port | a string representing the destination port
  hints | optional parameters to pass to the underlying transport

The documentation for this class was generated from the following file:

- include/uhd/transport/udp_zero_copy.hpp